/* 
 * Copyright (c) 2001 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: runtime.h,v 1.4 2001/11/27 10:43:10 malekith Exp $
 */

#include <stddef.h>

struct lambda_exp$ {
	void *fnc;
	void *closure;
};

#define ptroff long

void *xmalloc$(ptroff s);
void *make_closure$(ptroff s);
struct lambda_exp$ *make_lambda$(void *fnc, void *closure);

/* exceptions. */
struct try_block$;

struct try_block$ *push_try_block$(void);
void *pop_raised_value$(void);
void raise$(void *v);

/* strings */
struct string$ {
	ptroff len;
	char *data;
};

struct string$ *make_string$(ptroff size, char *content);

/* floats */
double *make_float$(double v);

